 ###############################################
#                                               #
#         L I V E   B U G   T R A C E R         #
#       v1.0 (30/05/2009)  par MenzAgitat       #
#                                               #
#          http://www.boulets-roxx.com          #
#        IRC:  irc.epiknet.org  #boulets        #
#              irc.teepi.net    #boulets        #
#                                               #
#     Mes scripts sont tlchargeables sur      #
#            http://www.eggdrop.fr              #
#        ou  http://www.egghelp.org             #
#                                               #
 ###############################################

#
# Description :
#
# Lorsqu'il est actif, Live Bug Tracer affiche automatiquement en partyline
# le contenu de la variable systme $::errorInfo ds qu'elle change d'tat.
# Si une quelconque erreur se produit dans un script, cette variable contient
# le dernier message d'erreur ainsi qu'un traceback de l'erreur.
# Si plusieurs erreurs identiques se produisent d'affile, seule la 1re
# occurence de l'erreur sera affiche afin d'viter le flood.
#
# Commandes disponibles (en partyline) :
#		.debugmode on				active le dbogueur
#		.debugmode off			dsactive le dbogueur
# 


#
# Changelog :
#
# 1.0 - 1re version
#

#
# LICENCE:
#		This program is free software; you can redistribute it and/or modify
#		it under the terms of the GNU General Public License as published by
#		the Free Software Foundation; either version 2 of the License, or
#		(at your option) any later version.
#
#		This program is distributed in the hope that it will be useful,
#		but WITHOUT ANY WARRANTY; without even the implied warranty of
#		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#		GNU General Public License for more details.
#
if { [lindex [split $version] 1] < 1061800 } { putloglev o * "\00304\002\[Live Bug Tracer - ERREUR\]\002\003 La version de votre eggdrop est \00304\002[lindex [split $version] 0]\002\003; \002Live Bug Tracer\002 ne fonctionnera correctement que sur les eggdrops version 1.6.18 ou suprieure." ; return }
if { $tcl_version < 8.4 } { putloglev o * "\00304\002\[Live Bug Tracer - ERREUR\]\002\003 \002Live Bug Tracer\002 ncessite que Tcl 8.4 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est \00304\002$tcl_version\002\003." ; return }
package require Tcl 8.4
if {[info commands LiveBugTracer::uninstall] eq "::LiveBugTracer::uninstall"} { LiveBugTracer::uninstall }
namespace eval LiveBugTracer {

#############################
#        PARAMETRES         #
#############################

	# Dboguage activ par dfaut ? (1 = oui / 0 = non )
	variable default_status 1
	# Commande servant  activer / dsactiver le dbogueur (devra tre tape prcde d'un ".")
	variable trace_command "debugmode"
	# Autorisations pour l'utilisation de la commande
	variable trace_auth "n|n"



#############################################################################
#  NE MODIFIEZ RIEN APRES CE CADRE SI VOUS NE SAVEZ PAS CE QUE VOUS FAITES  #
#############################################################################

	variable scriptname "Live Bug Tracer"
	variable version "1.0.20090530"
	variable status $default_status
	bind DCC $LiveBugTracer::trace_auth $LiveBugTracer::trace_command LiveBugTracer::activate_deactivate
	bind evnt - prerehash LiveBugTracer::uninstall
	proc uninstall {args} {
		putlog "Dsallocation des ressources de \002$LiveBugTracer::scriptname...\002"
		unbind DCC $LiveBugTracer::trace_auth $LiveBugTracer::trace_command LiveBugTracer::activate_deactivate
 		unbind evnt - prerehash LiveBugTracer::uninstall
		if { $LiveBugTracer::status } { trace remove variable ::errorInfo write LiveBugTracer::debug_catch_delayer }
		namespace delete ::LiveBugTracer
	}
	if { $LiveBugTracer::default_status } { trace add variable ::errorInfo write LiveBugTracer::debug_catch_delayer }
}

proc LiveBugTracer::activate_deactivate {hand idx args} {
	if { [set argument [string tolower $args]] eq "on" } {
		if { $LiveBugTracer::status } {
			putlog "\002\[Live Bug Tracer\]\002 le dbogueur est dj activ."
			return
		} else {
			variable status 1
			trace add variable ::errorInfo write LiveBugTracer::debug_catch_delayer
			putloglev o * "\002\[Live Bug Tracer\]\002 dbogueur activ"
		}
	} elseif { $argument eq "off" } {
			if { !$LiveBugTracer::status } {
				putlog "\002\[Live Bug Tracer\]\002 le dbogueur est dj dsactiv."
				return
			} else {
				variable status 0
				trace remove variable ::errorInfo write LiveBugTracer::debug_catch_delayer
				putloglev o * "\002\[Live Bug Tracer\]\002 dbogueur dsactiv"
				if { [info exists LiveBugTracer::last_error] } { unset LiveBugTracer::last_error }
			}
	} else {
		putlog "\00304\002\[Live Bug Tracer\]\002\003 \037Syntaxe\037 : \002.$LiveBugTracer::trace_command\002 \00314\[\003on\00314/\003off\00314\]\003     active / dsactive le dbogueur"
	}
}

proc LiveBugTracer::debug_catch_delayer {args} {
	# sans ce dlai, le traceback n'a pas le temps de se faire et la variable $errorInfo ne contient que l'erreur.
	utimer 1 LiveBugTracer::debug_catch
}

proc LiveBugTracer::debug_catch {args} {
	# Si l'erreur est la mme que la prcdente, on ne l'affiche pas
	if {([info exists LiveBugTracer::last_error]) && ([string first $LiveBugTracer::last_error $::errorInfo] != -1)} { return }
	variable last_error $::errorInfo
	foreach line [split $::errorInfo "\n"] {
		putloglev o * "\00314--\003\00315--\003->\00314 $line \003"
	}
}

putlog "\002*$LiveBugTracer::scriptname v$LiveBugTracer::version*\002 par MenzAgitat a t charg."
